exercises/testing-2/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  scope module: :web do
    root 'home#index'

    resources :repositories
  end
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html
end

exercises/testing-2/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/testing-2/app/models/repository.rb
# frozen_string_literal: true

class Repository < ApplicationRecord
  validates :link, presence: true
end

exercises/testing-2/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/testing-2/app/controllers/web/application_controller.rb
# frozen_string_literal: true

module Web
  class ApplicationController < ApplicationController
  end
end

exercises/testing-2/app/controllers/web/home_controller.rb
# frozen_string_literal: true

module Web
  class HomeController < Web::ApplicationController
    def index; end
  end
end

exercises/testing-2/app/controllers/web/repositories_controller.rb
# frozen_string_literal: true

# BEGIN

# END

module Web
  class RepositoriesController < Web::ApplicationController
    def index
      @repositories = Repository.all
    end

    def new
      @repository = Repository.new
    end

    def show
      @repository = Repository.find params[:id]
    end

    def create
      # BEGIN
      repository_info = FetchRepositoryInfo.call(permitted_params[:link])

      @repository = Repository.create(repository_info)

      if @repository.save
        redirect_to repositories_path, notice: t('success')
      else
        render :new, notice: t('fail')
      end
      # END
    end

    def edit
      @repository = Repository.find params[:id]
    end

    def update
      @repository = Repository.find params[:id]

      if @repository.update(permitted_params)
        redirect_to repositories_path, notice: t('success')
      else
        render :edit, notice: t('fail')
      end
    end

    def destroy
      @repository = Repository.find params[:id]

      if @repository.destroy
        redirect_to repositories_path, notice: t('success')
      else
        redirect_to repositories_path, notice: t('fail')
      end
    end

    private

    def permitted_params
      params.require(:repository).permit(:link)
    end
  end
end

exercises/testing-2/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/testing-2/app/views/web/repositories/_form.html.slim
= simple_form_for(@repository) do |f|
  = f.error_notification
  = f.error_notification message: f.object.errors[:base].to_sentence if f.object.errors[:base].present?

  = f.input :link

  = f.button :submit, class: 'btn btn-success mt-4 btn-block'

exercises/testing-2/app/views/web/repositories/edit.html.slim
- content_for :title do
  = t('.edit_repository')

== render 'form'

hr

.d-flex
  = link_to t('show'), @repository, class: 'btn btn-outline-primary me-2'
  = link_to t('back'), :back, class: 'btn btn-outline-primary'

exercises/testing-2/app/views/web/repositories/index.html.slim
- content_for :title do
  = t('.repositories')

table.table.table-striped.table-hover.mb-5
  thead
    tr
      th{ scope: :col } #
      th{ scope: :col } = t('.owner_name')
      th{ scope: :col } = t('.repo_name')
      th{ scope: :col } = t('.default_branch')
      th{ scope: :col } = t('.watchers_count')
      th{ scope: :col } = t('.language')
      th{ scope: :col } = t('.repo_created_at')
      th{ scope: :col } = t('.repo_updated_at')
      th

  tbody
    - @repositories.each_with_index do |repository, i|
      tr
        th{ scope: :col } = i + 1
        td = repository.owner_name
        td = repository.repo_name
        td = repository.default_branch
        td = repository.watchers_count
        td = repository.language
        td = repository.repo_created_at
        td = repository.repo_updated_at
        td.d-flex
          .me-4 = link_to t('edit'), edit_repository_path(repository)
          = link_to t('destroy'), repository, data: { confirm: t('destroy_confirmation') }, method: :delete, class: 'link-danger'

= link_to t('.new_repository'), new_repository_path, class: 'btn btn-primary'

exercises/testing-2/app/views/web/repositories/new.html.slim
- content_for :title do
  = t('.new_repository')

== render 'form'

hr

= link_to t('back'), :back, class: 'btn btn-outline-primary'

exercises/testing-2/app/views/web/repositories/show.html.slim
- content_for :title do
  = @repository.link

p
  strong.me-2 = t('.repo_name')
  = @repository.repo_name
p
  strong.me-2 = t('.owner_name')
  = @repository.owner_name
p
  strong.me-2 = t('.description')
  = @repository.description
p
  strong.me-2 = t('.default_branch')
  = @repository.default_branch
p
  strong.me-2 = t('.watchers_count')
  = @repository.watchers_count
p
  strong.me-2 = t('.language')
  = @repository.language
p
  strong.me-2 = t('.repo_created_at')
  = l(@repository.repo_created_at, format: :long)
p
  strong.me-2 = t('.repo_updated_at')
  = l(@repository.repo_updated_at, format: :long)

hr

.d-flex
  = link_to t('show'), @repository, class: 'btn btn-outline-primary me-2'
  = link_to t('back'), :back, class: 'btn btn-outline-primary'